﻿using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

namespace NotifyIcon //The namespace name is not important.
{

	//Inherit from IDisposable if you need Basic4ppc to free resources when the application is closed.
	public class NotifyIcon:IDisposable 
	{
		private System.Windows.Forms.NotifyIcon sb; //The "real" object.
		public event EventHandler MouseClick; //The event handler name must match the event name.
		private object[] eventObject; //One object[] for each event (one event here).
		
		//At least one public ctor.
		public NotifyIcon()
		{
			
			eventObject = new object[] {this,"MouseClick"}; //This is the object that will pass with the event.
			//It must be in that format exactly.

			sb.MouseClick += new MouseEventHandler(sb_MouseClick);
		}
		
		public void ChangeSetIcon(string path)
		{
			// Create a Bitmap object from an image file.
  			Bitmap bmp = new Bitmap(path);
  			// Get an Hicon for myBitmap. 
  			IntPtr Hicon = bmp.GetHicon();
  			// Create a new icon from the handle. 
  			Icon newIcon = Icon.FromHandle(Hicon);
			sb.Icon = newIcon;	
		}

		public double DLLVersion
		{
			get {return 1;}
		}
		
		public string About
		{
			get {return "By Taximania, ish :-)";}
		}
		//Use properties to allow syntax like: bar.Height = 50 OR x = bar.Height
		//The Control property returns the real control.
		public System.Windows.Forms.NotifyIcon Control
		{
			get {return sb;}
			set {sb = value;}
		}
	

		
		public string Text
		{
			get {return sb.Text;}
			set {sb.Text = value;}
		}
		//public string Icon
		//{
			//get {return sb.Icon;}
			//set {sb.Icon = value;}
		//}
		public bool Visible
		{
			get {return sb.Visible;}
			set {sb.Visible = value;}
		}
		

		private void sb_MouseClick(object sender, EventArgs e)
		{
			if (MouseClick != null) //You must test this.
			{
				MouseClick(eventObject,null);
			}
		}
		public void Dispose()
		{
			try
			{
				MouseClick = null;
				if (sb != null)
					sb.Dispose();
			}
			finally{}
		}

	}

}
